#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Daodan\AspectRatioComposition.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 6 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Daodan\AspectRatioComposition.fx"
#line 27
uniform int2 iUIAspectRatio <
ui_type = "drag";
ui_label = "Aspect Ratio";
ui_tooltip = "To control aspect ratio with a float\nadd 'ASPECT_RATIO_FLOAT' to preprocessor.\nOptional: 'ASPECT_RATIO_MAX=xyz'";
ui_min = 0; ui_max =  25;
> = int2(16, 9);
#line 35
uniform int iUIGridType <
ui_type = "combo";
ui_label = "Grid Type";
ui_items = "Off\0Fractions\0Golden Ratio\0";
> = 0;
#line 41
uniform int iUIGridFractions <
ui_type = "drag";
ui_label = "Fractions";
ui_tooltip = "Set 'Grid Type' to 'Fractions'";
ui_min = 1; ui_max = 5;
> = 3;
#line 48
uniform float4 UIGridColor <
ui_type = "color";
ui_label = "Grid Color";
> = float4(0.0, 0.0, 0.0, 1.0);
#line 57
float3 DrawGrid(float3 backbuffer, float3 gridColor, float aspectRatio, float fraction, float4 vpos)
{
float borderSize;
float fractionWidth;
#line 62
float3 retVal = backbuffer;
#line 64
if(aspectRatio < ReShade::AspectRatio)
{
borderSize = (1920 - 1080 * aspectRatio) / 2.0;
fractionWidth = (1920 - 2 * borderSize) / fraction;
#line 69
if(vpos.x < borderSize || vpos.x > (1920 - borderSize))
retVal = gridColor;
#line 72
if((vpos.y % (1080 / fraction)) < 1)
retVal = gridColor;
#line 75
if(((vpos.x - borderSize) % fractionWidth) < 1)
retVal = gridColor;
}
else
{
borderSize = (1080 - 1920 / aspectRatio) / 2.0;
fractionWidth = (1080 - 2 * borderSize) / fraction;
#line 83
if(vpos.y < borderSize || vpos.y > (1080 - borderSize))
retVal = gridColor;
#line 86
if((vpos.x % (1920 / fraction)) < 1)
retVal = gridColor;
#line 89
if(((vpos.y - borderSize) % fractionWidth) < 1)
retVal = gridColor;
#line 92
}
#line 94
if(vpos.x <= 1 || vpos.x >= 1920-1 || vpos.y <= 1 || vpos.y >= 1080-1)
retVal = gridColor;
#line 97
return retVal;
}
#line 104
float3 AspectRatioComposition_PS(float4 vpos : SV_Position, float2 texcoord : TexCoord) : SV_Target
{
float3 color = tex2D(ReShade::BackBuffer, texcoord).rgb;
float3 retVal = color;
#line 109
float userAspectRatio;
#line 114
userAspectRatio = (float)iUIAspectRatio.x / (float)iUIAspectRatio.y;
#line 117
if(iUIGridType == 1)
retVal = DrawGrid(color, UIGridColor.rgb, userAspectRatio, iUIGridFractions, vpos);
else if(iUIGridType == 2)
{
retVal = DrawGrid(color, UIGridColor.rgb, userAspectRatio,  1.6180339887, vpos);
retVal = DrawGrid(retVal, UIGridColor.rgb, userAspectRatio,  1.6180339887, float4(1920, 1080, 0, 0) - vpos);
}
#line 125
return lerp(color, retVal, UIGridColor.w);
}
#line 128
technique AspectRatioComposition
{
pass
{
VertexShader = PostProcessVS;
PixelShader = AspectRatioComposition_PS;
}
}
