#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Dither.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 2560 * (1.0 / 1440);
static const float2 PixelSize = float2((1.0 / 2560), (1.0 / 1440));
static const float2 ScreenSize = float2(2560, 1440);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 25 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Dither.fx"
#line 35
uniform float fDithering <
ui_label = "Dithering";
ui_type  = "drag";
ui_min   = 0.0;
ui_max   = 1.0;
ui_step  = 0.001;
> = 0.5;
#line 43
uniform float fQuantization <
ui_label   = "Quantization";
ui_tooltip = "Use to simulate lack of colors: 8.0 for 8bits, 16.0 for 16bits etc.\n"
"Set to 0.0 to disable quantization.\n"
"Only enabled if dithering is enabled as well.";
ui_type    = "drag";
ui_min     = 0.0;
ui_max     = 255.0;
ui_step    = 1.0;
> = 0.0;
#line 55
uniform int iDitherMode <
ui_label = "Dither Mode";
ui_type  = "combo";
ui_items = "Add\0Multiply\0";
> = 0;
#line 63
sampler2D sRetroFog_BackBuffer {
Texture = ReShade::BackBufferTex;
SRGBTexture = true;
};
#line 71
int get_bayer(int2 i) {
static const int bayer[8 * 8] = {
0, 48, 12, 60,  3, 51, 15, 63,
32, 16, 44, 28, 35, 19, 47, 31,
8, 56,  4, 52, 11, 59,  7, 55,
40, 24, 36, 20, 43, 27, 39, 23,
2, 50, 14, 62,  1, 49, 13, 61,
34, 18, 46, 30, 33, 17, 45, 29,
10, 58,  6, 54,  9, 57,  5, 53,
42, 26, 38, 22, 41, 25, 37, 21
};
return bayer[i.x + 8 * i.y];
}
#line 86
float2 fmod(float2 a, float2 b) {
float2 c = frac(abs(a / b)) * abs(b);
return (a < 0) ? -c : c;
}
#line 92
float dither(float x, float2 uv) {
#line 100
int2 index = int2(uv * ReShade::ScreenSize) % 8;
float limit = (float(get_bayer(index) + 1) / 64.0) * step(index.x, 8);
#line 104
return step(limit, x);
}
#line 107
float get_luma_linear(float3 color) {
return dot(color, float3(0.2126, 0.7152, 0.0722));
}
#line 111
float rand(float2 uv, float t) {
float seed = dot(uv, float2(12.9898, 78.233));
float noise = frac(sin(seed) * 43758.5453 + t);
return noise;
}
#line 119
void PS_Dither(
float4 position  : SV_POSITION,
float2 uv        : TEXCOORD,
out float4 color : SV_TARGET
) {
color = tex2D(sRetroFog_BackBuffer, uv);
#line 126
if (fQuantization > 0.0)
color = round(color * fQuantization) / fQuantization;
#line 129
float luma = get_luma_linear(color.rgb);
float pattern = dither(luma, uv);
#line 132
if (iDitherMode == 0) 
color.rgb += color.rgb * pattern * fDithering;
else                  
color.rgb *= lerp(1.0, pattern, fDithering);
}
#line 140
technique Dither {
pass {
VertexShader = PostProcessVS;
PixelShader  = PS_Dither;
SRGBWriteEnable = true;
}
}

