#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\LUTTools.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShadeUI.fxh"
#line 30 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\LUTTools.fx"
#line 32
uniform int LutRes <
ui_label = "LUT box resolution";
ui_tooltip = "Horizontal resolution equals value squared.\n"
"Default 32 is 1024.\n"
"To set texture size and name for ApplyLUT, define\n"
" LUT_BLOCK_SIZE [number]\n"
"and \n"
" LUT_FILE_NAME [name]";
ui_type = "drag";
ui_category = "Display LUT settings";
ui_min = 8; ui_max = 128; ui_step = 1;
> = 32;
#line 45
uniform bool VerticalOrietation <       ui_type = "input"; 
ui_label = "Vertical LUT";
ui_tooltip = "Select LUT texture orientation, default is horizontal.\n"
"To change orientation for input LUT, add PreProcessor definition 'LUT_VERTICAL true'.";
ui_category = "Display LUT settings";
> = false;
#line 52
uniform float2 LutChromaLuma <      ui_type = "slider"; 
ui_label = "LUT chroma/luma blend";
ui_tooltip = "How much LUT affects chrominance/luminance";
ui_category = "Apply LUT settings";
ui_min = 0.0; ui_max = 1.0; ui_step = 0.005;
> = float2(1.0, 1.0);
#line 64
int2 toLut2D(int3 lut3D)
{
#line 69
return int2(lut3D.x+lut3D.z, lut3D.y);
#line 71
}
#line 84
texture LUTTex < source =  "lut.png";>{ Width =  int2( 32* 32,  32).x; Height =  int2( 32* 32,  32).y; Format = RGBA8; };
sampler LUTSampler {Texture = LUTTex; Format = RGBA8;};
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 88 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\LUTTools.fx"
#line 91
float3 DisplayLutPS(float4 vois : SV_Position, float2 TexCoord : TEXCOORD) : SV_Target
{
#line 94
float2 LutBounds;
if (VerticalOrietation)
LutBounds = float2(LutRes, LutRes*LutRes);
else
LutBounds = float2(LutRes*LutRes, LutRes);
LutBounds *=  float2((1.0 / 1920), (1.0 / 1080));
#line 101
if( any(TexCoord>=LutBounds) ) return tex2D(ReShade::BackBuffer, TexCoord).rgb;
else
{
#line 105
float2 Gradient = TexCoord* float2(1920, 1080)/LutRes;
#line 107
float3 LUT;
LUT.rg = frac(Gradient)-0.5/LutRes;
LUT.rg /= 1.0-1.0/LutRes;
LUT.b = floor(VerticalOrietation? Gradient.g : Gradient.r)/(LutRes-1);
#line 112
return LUT;
}
}
#line 117
void ApplyLutPS(float4 vois : SV_Position, float2 TexCoord : TEXCOORD, out float3 Image : SV_Target)
{
#line 120
Image = tex2D(ReShade::BackBuffer, TexCoord).rgb;
#line 123
float3 lut3D = Image*( 32-1);
#line 126
float2 lut2D[2];
#line 136
lut2D[0].x = floor(lut3D.z)* 32+lut3D.x;
lut2D[0].y = lut3D.y;
#line 139
lut2D[1].x = ceil(lut3D.z)* 32+lut3D.x;
lut2D[1].y = lut3D.y;
#line 144
lut2D[0] = (lut2D[0]+0.5)* 1.0/ int2( 32* 32,  32);
lut2D[1] = (lut2D[1]+0.5)* 1.0/ int2( 32* 32,  32);
#line 148
float3 LutImage = lerp(
tex2D(LUTSampler, lut2D[0]).rgb, 
tex2D(LUTSampler, lut2D[1]).rgb, 
frac(lut3D.z)
);
#line 155
if ( all(LutChromaLuma==1.0) )
Image = LutImage;
else
{
Image = lerp(
normalize(Image),
normalize(LutImage),
LutChromaLuma.x
)*lerp(
length(Image),
length(LutImage),
LutChromaLuma.y
);
}
}
#line 176
technique DisplayLUT <
ui_label = "Display LUT";
ui_tooltip =
"Display generated-neutral LUT texture in left to corner of the screen\n\n"
"How to use:\n"
"* adjust lut size\n"
"* (optionally) adjust color effecs to bake shaders into LUT\n"
"* take a screenshot\n"
"* adjust and crop screenshot to texture using external image editor\n"
"* load LUT texture in 'Apply LUT .fx'";
>
{
pass
{
VertexShader = PostProcessVS;
PixelShader = DisplayLutPS;
}
}
#line 195
technique ApplyLUT <
ui_label = "Apply LUT";
ui_tooltip =
"Apply LUT texture color adjustment\n"
"To change texture name, add following to global preprocessor definitions:\n\n"
"   LUT_FILE_NAME 'YourLUT.png'\n\n"
"To change LUT texture resolution, define:\n\n"
"   LUT_BLOCK_SIZE 17\n\n"
"To change LUT texture orientation, define:\n\n"
"   LUT_VERTICAL true";
>
{
pass
{
VertexShader = PostProcessVS;
PixelShader = ApplyLutPS;
}
}

