#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\AstrayFX\Trails.fx"
#line 26
uniform float Persistence <
ui_type = "drag";
ui_min = 0.0; ui_max = 1.00;
ui_label = "Persistence";
ui_tooltip = "Increase persistence longer the trail or afterimage.\n"
"If pushed out the effect is alot like long exposure.\n"
"This can be used for light painting in games.\n"
"1000/1 is 1.0, so 1/2 is 0.5 and so forth.\n"
"Default is 0.25, 0 is infinity.";
> = 0.25;
#line 49
uniform float TQ <
ui_type = "drag";
ui_min = 0.0; ui_max = 1.0;
ui_label = "Trail Blur Quality";
ui_tooltip = "Adjust Trail Blur Quality.\n"
"Default is Zero.";
> = 0.0;
#line 63
uniform bool PS2 <
ui_label = "PS2 Style Echo";
ui_tooltip = "This enables PS2 Style Echo in your game.\n"
"This disables Trail Quality.";
> = false;
#line 115
static const int Allow_Depth = 0;
static const int Depth_Map = 0;
static const float Depth_Map_Adjust = 250.0;
static const int Depth_Map_Flip = 0;
static const int Invert_Depth = 0;
static const int Depth_View = 0;
static const int Hard_CutOff = 0;
#line 124
texture DepthBufferTex : DEPTH;
#line 126
sampler DepthBuffer
{
Texture = DepthBufferTex;
};
#line 131
texture BackBufferTex : COLOR;
#line 133
sampler BackBuffer
{
Texture = BackBufferTex;
};
#line 138
texture CurrentBackBufferT  { Width = 3840; Height = 2160; Format = RGBA8;};
#line 140
sampler CBackBuffer
{
Texture = CurrentBackBufferT;
};
#line 146
texture PBB  { Width = 3840; Height = 2160; Format = RGBA8; MipLevels = 2;};
#line 148
sampler PBackBuffer
{
Texture = PBB;
};
#line 153
texture PSBB  { Width = 3840; Height = 2160; Format = RGBA8;};
#line 155
sampler PSBackBuffer
{
Texture = PSBB;
};
#line 163
float Depth(in float2 texcoord : TEXCOORD0)
{
if (Depth_Map_Flip)
texcoord.y =  1 - texcoord.y;
#line 168
float zBuffer = tex2D(DepthBuffer, texcoord).x; 
#line 172
float Far = 1.0, Near = 0.125/250.0; 
#line 174
float2 Z = float2( zBuffer, 1-zBuffer );
#line 176
if (Depth_Map == 0)
zBuffer = Far * Near / (Far + Z.x * (Near - Far));
else if (Depth_Map == 1)
zBuffer = Far * Near / (Far + Z.y * (Near - Far));
#line 181
return saturate(zBuffer);
}
#line 184
float3 T_Out(float4 position : SV_Position, float2 texcoord : TEXCOORD) : SV_Target
{
float TQA = TQ, D = Depth(texcoord);
if(PS2)
TQA = 0;
#line 190
float3 C = tex2D(BackBuffer, texcoord).rgb;
#line 193
float3 P = tex2Dlod(PBackBuffer, float4(texcoord,0,TQA)).rgb;
#line 196
float Per = 1-Persistence;
#line 201
D = smoothstep(0,Depth_Map_Adjust,D);
#line 203
if(Hard_CutOff)
D = step(0.5,D);
#line 206
if(Invert_Depth)
D = 1-D;
#line 209
if(!PS2)
{
P *= Per;
C = max( tex2D(BackBuffer, texcoord).rgb, P);
#line 214
}
else
{
C = (1-Per) * C + Per * P;
#line 219
}
#line 226
if(Allow_Depth)
C = lerp(C,tex2D(BackBuffer, texcoord).rgb,saturate(D));
#line 229
if(Depth_View)
C = D;
#line 232
return C;
}
#line 235
void Current_BackBuffer_T(float4 position : SV_Position, float2 texcoord : TEXCOORD, out float4 color : SV_Target0)
{
color = tex2D(BackBuffer,texcoord);
}
#line 240
void Past_BB(float4 position : SV_Position, float2 texcoord : TEXCOORD, out float4 Past : SV_Target0, out float4 PastSingle : SV_Target1)
{   float2 samples[12] = {
float2(-0.326212, -0.405805),
float2(-0.840144, -0.073580),
float2(-0.695914, 0.457137),
float2(-0.203345, 0.620716),
float2(0.962340, -0.194983),
float2(0.473434, -0.480026),
float2(0.519456, 0.767022),
float2(0.185461, -0.893124),
float2(0.507431, 0.064425),
float2(0.896420, 0.412458),
float2(-0.321940, -0.932615),
float2(-0.791559, -0.597705)
};
#line 256
float4 sum_A = tex2D(BackBuffer,texcoord), sum_B = 0;
#line 258
if(!PS2)
{
float Adjust = TQ* float2((1.0 / 3840), (1.0 / 2160)).x;
[loop]
for (int i = 0; i < 12; i++)
{
sum_A += tex2Dlod(BackBuffer, float4(texcoord + Adjust * samples[i],0,0));
#line 266
}
Past = sum_A * 0.07692307;
PastSingle = 0;
}
else
{
Past = sum_A;
PastSingle = 0;
}
}
#line 279
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
technique Trails
{
pass CBB
{
VertexShader = PostProcessVS;
PixelShader = Current_BackBuffer_T;
RenderTarget = CurrentBackBufferT;
}
pass Trails
{
VertexShader = PostProcessVS;
PixelShader = T_Out;
}
pass PBB
{
VertexShader = PostProcessVS;
PixelShader = Past_BB;
RenderTarget0 = PBB;
RenderTarget1 = PSBB;
#line 305
}
}

