#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\UIMaskCreator.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 2560 * (1.0 / 1440);
static const float2 PixelSize = float2((1.0 / 2560), (1.0 / 1440));
static const float2 ScreenSize = float2(2560, 1440);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 11 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\UIMaskCreator.fx"
#line 13
uniform int Radius<
ui_label = "Brush Radius";
ui_min = 0; ui_max = 256;
ui_tooltip = "Hold down spacebar while adjusting so that you\n"
"don't draw behind the overlay on accident.";
ui_type = "slider";
> = 16;
#line 21
uniform bool SquareCursor <
ui_label = "Square Cursor";
ui_tooltip = "Hold down spacebar while adjusting so that you\n"
"don't draw behind the overlay on accident.";
> = 0;
#line 27
uniform bool ReadyForScreenshot <
ui_label = "Ready For Screenshot";
ui_tooltip = "This turns the parts of the screen not covered by \n"
"the mask white, and disables the cursor in preparation \n"
"for a screenshot. \n \n"
"Hold down spacebar while adjusting so that you\n"
"don't draw behind the overlay on accident.";
> = 0;
#line 36
uniform float2 MouseCoord < source = "mousepoint";>;
uniform float2 MouseDelta < source = "mousedelta";>;
#line 39
uniform bool LeftMouseButtonDown <source = "mousebutton"; keycode = 0;>;
uniform bool LeftMouseButtonPressed <source = "mousebutton"; keycode = 0; mode = "press";>;
#line 42
uniform bool RightMouseButtonDown <source = "mousebutton"; keycode = 1;>;
uniform bool RightMouseButtonPressed <source = "mousebutton"; keycode = 1; mode = "press";>;
#line 45
uniform bool SpaceBarDown <source = "key"; keycode = 0x20;>;
uniform bool CtrlDown <source = "key"; keycode = 0x11;>;
uniform bool Reset <source = "key"; keycode = 0x52;>;
#line 51
texture MaskLayer {Width = 2560; Height = 1440; Format = R8;};
sampler sMaskLayer {Texture = MaskLayer;};
#line 55
bool WithinRadius(float2 texcoord)
{
float2 coordinates = texcoord *  float2(2560, 1440);
float2 coordinateDelta = abs(coordinates - MouseCoord);
int distanceFromCursor;
if (SquareCursor)
{
distanceFromCursor = max(coordinateDelta.x, coordinateDelta.y);
}
else
{
distanceFromCursor = sqrt(dot(1, coordinateDelta * coordinateDelta));
}
#line 69
return distanceFromCursor <= Radius;
}
#line 72
void CursorPS(float4 pos : SV_Position, float2 texcoord : Texcoord, out float4 output : SV_Target)
{
if(ReadyForScreenshot) discard;
output = tex2D(ReShade::BackBuffer, texcoord);
output *=  1 - (tex2D(sMaskLayer, texcoord).rrrr);
if(WithinRadius(texcoord)) output = lerp(output, 1, 0.333);
}
#line 80
void WriteToMaskLayerPS(float4 pos : SV_Position, float2 texcoord : Texcoord, out float output : SV_Target)
{
if(SpaceBarDown || CtrlDown || ReadyForScreenshot) discard;
else if (Reset) output = 0;
else if(WithinRadius(texcoord))
{
if(LeftMouseButtonDown) output = 1;
else if(RightMouseButtonDown) output = 0;
else discard;
}
else discard;
}
#line 93
void OutputMaskLayerPS(float4 pos : SV_Position, float2 texcoord : Texcoord, out float4 output : SV_Target)
{
if(ReadyForScreenshot)
{
output = 1 - tex2D(sMaskLayer, texcoord).rrrr;
}
else discard;
}
#line 103
technique UIMaskCreator<
ui_tooltip = "Press R to reset the mask layer, left click to mask, right click to erase, \n"
"and use spacebar when changing settings to prevent it from writing behind the \n"
"overlay.\n\n"
"You can use a blur shader such as GaussianBlur.fx to soften HUD edges once you are\n"
"ready to screenshot the mask.";>
#line 110
{
pass Cursor
{
VertexShader = PostProcessVS;
PixelShader = CursorPS;
}
pass WriteToMaskLayer
{
VertexShader = PostProcessVS;
PixelShader = WriteToMaskLayerPS;
RenderTarget = MaskLayer;
}
pass OutputMaskLayerPS
{
VertexShader = PostProcessVS;
PixelShader = OutputMaskLayerPS;
}
}

